<?php
/* Autor...: William L. Taype Perez */
/* Esquema.: SEG_Usuario.xml */
/* Generado: 2022-01-25 15:46:04 */

/* Mantenimiento de los registros de la tabla SEG_Usuario */
abstract class BaseSEG_UsuarioDP extends SEG_UsuarioBV
{
    /* Constructor ( Establece los valores desde un objeto SEG_UsuarioBN ) */
    public function __construct( SEG_UsuarioBN $o_SEG_UsuarioBN = null )
    {
        parent::__construct();
        if ( !is_null( $o_SEG_UsuarioBN ) )
        {
            $this->setByBN( $o_SEG_UsuarioBN );
        }
    }

    public $b_Debug = false;

    public function getDebug()
    {
        if( SF_DEBUG )
        {
            $this->b_Debug = true;
        }
        return $this->b_Debug;
    }

    public function setDebug( $v )
    {
        $this->b_Debug = $v;
    }

    /* Establece los valores desde un objeto SEG_UsuarioBN */
    public function setByBN( SEG_UsuarioBN $o_SEG_UsuarioBN )
    {
        if ( !is_null( $o_SEG_UsuarioBN->getIdUsuario() ) )
        {
            $this->setIdUsuario( $o_SEG_UsuarioBN->getIdUsuario() );
        }
        if ( !is_null( $o_SEG_UsuarioBN->getIdCompania() ) )
        {
            $this->setIdCompania( $o_SEG_UsuarioBN->getIdCompania() );
        }
        if ( !is_null( $o_SEG_UsuarioBN->getIdRol() ) )
        {
            $this->setIdRol( $o_SEG_UsuarioBN->getIdRol() );
        }
        if ( !is_null( $o_SEG_UsuarioBN->getUsuarioNombre() ) )
        {
            $this->setUsuarioNombre( $o_SEG_UsuarioBN->getUsuarioNombre() );
        }
        if ( !is_null( $o_SEG_UsuarioBN->getUsuarioPassword() ) )
        {
            $this->setUsuarioPassword( $o_SEG_UsuarioBN->getUsuarioPassword() );
        }
        if ( !is_null( $o_SEG_UsuarioBN->getUsuarioContrasenia() ) )
        {
            $this->setUsuarioContrasenia( $o_SEG_UsuarioBN->getUsuarioContrasenia() );
        }
        if ( !is_null( $o_SEG_UsuarioBN->getFechaCambioPwd() ) )
        {
            $this->setFechaCambioPwd( $o_SEG_UsuarioBN->getFechaCambioPwd() );
        }
        if ( !is_null( $o_SEG_UsuarioBN->getHoraCambioPwd() ) )
        {
            $this->setHoraCambioPwd( $o_SEG_UsuarioBN->getHoraCambioPwd() );
        }
        if ( !is_null( $o_SEG_UsuarioBN->getPermisoAdPwd() ) )
        {
            $this->setPermisoAdPwd( $o_SEG_UsuarioBN->getPermisoAdPwd() );
        }
        if ( !is_null( $o_SEG_UsuarioBN->getContadorPwd() ) )
        {
            $this->setContadorPwd( $o_SEG_UsuarioBN->getContadorPwd() );
        }
        if ( !is_null( $o_SEG_UsuarioBN->getEnUso() ) )
        {
            $this->setEnUso( $o_SEG_UsuarioBN->getEnUso() );
        }
        if ( !is_null( $o_SEG_UsuarioBN->getDeshabilitadoFlg() ) )
        {
            $this->setDeshabilitadoFlg( $o_SEG_UsuarioBN->getDeshabilitadoFlg() );
        }
        if ( !is_null( $o_SEG_UsuarioBN->getLogonFecha() ) )
        {
            $this->setLogonFecha( $o_SEG_UsuarioBN->getLogonFecha() );
        }
        if ( !is_null( $o_SEG_UsuarioBN->getLogonHora() ) )
        {
            $this->setLogonHora( $o_SEG_UsuarioBN->getLogonHora() );
        }
        if ( !is_null( $o_SEG_UsuarioBN->getIdioma() ) )
        {
            $this->setIdioma( $o_SEG_UsuarioBN->getIdioma() );
        }
        if ( !is_null( $o_SEG_UsuarioBN->getInicioFecha() ) )
        {
            $this->setInicioFecha( $o_SEG_UsuarioBN->getInicioFecha() );
        }
        if ( !is_null( $o_SEG_UsuarioBN->getFinFecha() ) )
        {
            $this->setFinFecha( $o_SEG_UsuarioBN->getFinFecha() );
        }
        if ( !is_null( $o_SEG_UsuarioBN->getDireccionIP() ) )
        {
            $this->setDireccionIP( $o_SEG_UsuarioBN->getDireccionIP() );
        }
        if ( !is_null( $o_SEG_UsuarioBN->getUsuarioImagen() ) )
        {
            $this->setUsuarioImagen( $o_SEG_UsuarioBN->getUsuarioImagen() );
        }
        if ( !is_null( $o_SEG_UsuarioBN->getCorreo() ) )
        {
            $this->setCorreo( $o_SEG_UsuarioBN->getCorreo() );
        }
        if ( !is_null( $o_SEG_UsuarioBN->getFechaCreacion() ) )
        {
            $this->setFechaCreacion( $o_SEG_UsuarioBN->getFechaCreacion() );
        }
        if ( !is_null( $o_SEG_UsuarioBN->getUsuarioCreacion() ) )
        {
            $this->setUsuarioCreacion( $o_SEG_UsuarioBN->getUsuarioCreacion() );
        }
        if ( !is_null( $o_SEG_UsuarioBN->getFechaModificacion() ) )
        {
            $this->setFechaModificacion( $o_SEG_UsuarioBN->getFechaModificacion() );
        }
        if ( !is_null( $o_SEG_UsuarioBN->getUsuarioModificacion() ) )
        {
            $this->setUsuarioModificacion( $o_SEG_UsuarioBN->getUsuarioModificacion() );
        }
    }

    /* Graba un nuevo registro */
    public function save()
    {
        $this->validateRecord();
        $o_SEG_UsuarioFN = new SEG_UsuarioFN();
        $o_SEG_UsuarioBN = $o_SEG_UsuarioFN->selectByPk( $this->getIdUsuario() );
        if ( is_null( $o_SEG_UsuarioBN ) )
        {
            $s_SQLQuery1 = "INSERT INTO SEG_Usuario ( ";
            $s_SQLQuery2 = "VALUES ( ";
            $s_Separator = "";
            if ( !is_null( $this->getIdUsuario() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdUsuario";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdUsuario()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdCompania() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdCompania";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdCompania()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdRol() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdRol";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdRol()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioNombre() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioNombre";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioNombre()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioPassword() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioPassword";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioPassword()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioContrasenia() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioContrasenia";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioContrasenia()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCambioPwd() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaCambioPwd";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaCambioPwd()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getHoraCambioPwd() ) )
            {
                $s_SQLQuery1 .= $s_Separator."HoraCambioPwd";
                $s_SQLQuery2 .= $s_Separator."'".$this->getHoraCambioPwd()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPermisoAdPwd() ) )
            {
                $s_SQLQuery1 .= $s_Separator."PermisoAdPwd";
                $s_SQLQuery2 .= $s_Separator."".$this->getPermisoAdPwd()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getContadorPwd() ) )
            {
                $s_SQLQuery1 .= $s_Separator."ContadorPwd";
                $s_SQLQuery2 .= $s_Separator."".$this->getContadorPwd()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEnUso() ) )
            {
                $s_SQLQuery1 .= $s_Separator."EnUso";
                $s_SQLQuery2 .= $s_Separator."'".$this->getEnUso()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDeshabilitadoFlg() ) )
            {
                $s_SQLQuery1 .= $s_Separator."DeshabilitadoFlg";
                $s_SQLQuery2 .= $s_Separator."'".$this->getDeshabilitadoFlg()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getLogonFecha() ) )
            {
                $s_SQLQuery1 .= $s_Separator."LogonFecha";
                $s_SQLQuery2 .= $s_Separator."'".$this->getLogonFecha()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getLogonHora() ) )
            {
                $s_SQLQuery1 .= $s_Separator."LogonHora";
                $s_SQLQuery2 .= $s_Separator."'".$this->getLogonHora()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdioma() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Idioma";
                $s_SQLQuery2 .= $s_Separator."'".$this->getIdioma()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getInicioFecha() ) )
            {
                $s_SQLQuery1 .= $s_Separator."InicioFecha";
                $s_SQLQuery2 .= $s_Separator."'".$this->getInicioFecha()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFinFecha() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FinFecha";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFinFecha()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDireccionIP() ) )
            {
                $s_SQLQuery1 .= $s_Separator."DireccionIP";
                $s_SQLQuery2 .= $s_Separator."'".$this->getDireccionIP()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioImagen() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioImagen";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioImagen()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCorreo() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Correo";
                $s_SQLQuery2 .= $s_Separator."'".$this->getCorreo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioCreacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioModificacion";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery = $s_SQLQuery1." ) ".$s_SQLQuery2." );";
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }
            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
        }
        else
        {
            throw new Exception( "El id ya esta registrado." );
        }
        return true;
    }

    /* Actualiza los datos del registro */
    public function update()
    {
        $this->validateRecord();
        if ( true )
        {
            $s_SQLQuery = "UPDATE SEG_Usuario SET ";
            $s_Separator = "";
            if ( !is_null( $this->getIdCompania() ) )
            {
                $s_SQLQuery .= $s_Separator."IdCompania = ".$this->getIdCompania()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdRol() ) )
            {
                $s_SQLQuery .= $s_Separator."IdRol = '".$this->getIdRol()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioNombre() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioNombre = '".$this->getUsuarioNombre()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioPassword() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioPassword = '".$this->getUsuarioPassword()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioContrasenia() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioContrasenia = '".$this->getUsuarioContrasenia()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCambioPwd() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaCambioPwd = '".$this->getFechaCambioPwd()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getHoraCambioPwd() ) )
            {
                $s_SQLQuery .= $s_Separator."HoraCambioPwd = '".$this->getHoraCambioPwd()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getPermisoAdPwd() ) )
            {
                $s_SQLQuery .= $s_Separator."PermisoAdPwd = ".$this->getPermisoAdPwd()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getContadorPwd() ) )
            {
                $s_SQLQuery .= $s_Separator."ContadorPwd = ".$this->getContadorPwd()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEnUso() ) )
            {
                $s_SQLQuery .= $s_Separator."EnUso = '".$this->getEnUso()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDeshabilitadoFlg() ) )
            {
                $s_SQLQuery .= $s_Separator."DeshabilitadoFlg = '".$this->getDeshabilitadoFlg()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getLogonFecha() ) )
            {
                $s_SQLQuery .= $s_Separator."LogonFecha = '".$this->getLogonFecha()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getLogonHora() ) )
            {
                $s_SQLQuery .= $s_Separator."LogonHora = '".$this->getLogonHora()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdioma() ) )
            {
                $s_SQLQuery .= $s_Separator."Idioma = '".$this->getIdioma()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getInicioFecha() ) )
            {
                $s_SQLQuery .= $s_Separator."InicioFecha = '".$this->getInicioFecha()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFinFecha() ) )
            {
                $s_SQLQuery .= $s_Separator."FinFecha = '".$this->getFinFecha()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDireccionIP() ) )
            {
                $s_SQLQuery .= $s_Separator."DireccionIP = '".$this->getDireccionIP()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioImagen() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioImagen = '".$this->getUsuarioImagen()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getCorreo() ) )
            {
                $s_SQLQuery .= $s_Separator."Correo = '".$this->getCorreo()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaCreacion = '".$this->getFechaCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioCreacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioCreacion = '".$this->getUsuarioCreacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."FechaModificacion = '".$this->getFechaModificacion()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioModificacion() ) )
            {
                $s_SQLQuery .= $s_Separator."UsuarioModificacion = '".$this->getUsuarioModificacion()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery .= " WHERE  IdUsuario = '".$this->getIdUsuario()."';";
            if( $this->getDebug() ){ pr( $s_SQLQuery ); }

            $o_Resource = Conexion::getConexion();
            $o_Statement = $o_Resource->createStatement();
            $o_Statement->executeQuery( $s_SQLQuery );
        }
        else
        {
            throw new Exception( "El id no esta registrado." );
        }
        return true;
    }

    /* Elimina el registro */
    public function delete()
    {
        $s_SQLQuery = "DELETE FROM SEG_Usuario WHERE  IdUsuario = '".$this->getIdUsuario()."';";
        if( $this->getDebug() ){ pr( $s_SQLQuery ); }
        $o_Resource = Conexion::getConexion();
        $o_Statement = $o_Resource->createStatement();
        $o_Statement->executeQuery( $s_SQLQuery );
        return true;
    }

}
?>